function MissionSetup()
    print("***************************************** 2_GN Mission setup *************************************")
    LoadPedModels({ 140 })
    MissionDontFadeIn()
    AreaLoadSpecialEntities("2s07", true)
    CutSceneSetActionNode("2-S07")
    AreaEnsureSpecialEntitiesAreCreated()
    PlayCutsceneWithLoad("2-S07", true, true, false)
end

function MissionCleanup()
    AreaLoadSpecialEntities("2s07", false)
    UnpauseGameClock()
    ButtonHistoryIgnoreController(false)
    PedLockTarget(gPlayer, -1)
    PedSetUniqueModelStatus(140, 1)
    AreaRevertToDefaultPopulation()
    CounterMakeHUDVisible(false, false)
    CameraSetWidescreen(false)
    PlayerSetControl(1)
    SoundStopInteractiveStream()
    SoundEnableInteractiveMusic(true)
    PlayerWeaponHudLock(false)
    CameraAllowChange(true)
    PlayerIgnoreTargeting(false)
    DATUnload(2)
end

function main()
    print("*************************** 2_GN main ******************************************")
    DATLoad("2_S07.DAT", 2)
    DATInit()
    DisablePunishmentSystem(true)
    PedSetUniqueModelStatus(140, -1)
    gFMidget = PedCreatePoint(140, POINTLIST._2_GN_MIDGETHANG, 1)
    PlayerSetControl(0)
    PlayerSetPosPoint(POINTLIST._2_GN_MissionEnd, 1)
    PedSetPosPoint(gFMidget, POINTLIST._2_GN_MidgetHang, 1)
    print(" ***************************** Gnomes Have Started **********************************")
    CollectiblesSetTypeAvailable(0, true)
    CameraFade(500, 0)
    Wait(500)
    PedDelete(gFMidget)
    PlayerSetPosPoint(POINTLIST._2_GN_MissionEnd, 1)
    CameraReset()
    CameraReturnToPlayer()
    CameraFade(500, 1)
    Wait(500)
    TextPrint("2_S07_MOBJ_01", 5, 1)
    MissionSucceed(false, false, false)
end

function F_Socialize(pedId, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 23, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 27, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 24, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 28, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 29, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 30, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 33, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 34, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 36, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 25, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 26, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 31, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 32, bDisable)
    PlayerSocialDisableActionAgainstPed(pedId, 35, bDisable)
end
